import template from './attribute-group-editor.template.html';

/**
 * @todo añadir estado de carga
 */
class controller{
	constructor(AttributeGroup) {
		'ngInject';
		this.AttributeGroup = AttributeGroup;
	}

	/**
	 * [$onInit description]
	 * @return {[type]} [description]
	 */
	$onInit() {
		// Cargamos los atributos no asignados al conjuto
		if(! this.hasOwnProperty('unassigneds') || this.unassigneds === null) {
			let unassignedsP = this.AttributeGroup.unassigneds(this.group.id).then( (response) => this.unassigneds = { attrs : response.attrs } );
		}

		if(!this.group.parent_id) {
			let childrenP = this.AttributeGroup.children(this.group.id).then( (children) => this.children = children );
		}

		this.sortableOptions = {
			handle: ".sort-handle"
		};
	}

	/**
	 * [addGroup description]
	 * @param {[type]} name [description]
	 */
	addSubset(name) {
		this.group.subsets.push({ name, attrs: [] });

		this.showSubsetForm = false;
		this.newSubsetName = '';
	}

	/**
	 * Remove subset
	 * @param  {[type]} index [description]
	 * @return {[type]}       [description]
	 */
	removeSubset(index) {
		// Quitamos los atributos primero para ponerlos en la lista alternativa
		this.insertInto(this.unassigneds, this.group.subsets[index].attrs);

		this.group.subsets.splice(index, 1);
	}

	/**
	 * [removeSelection description]
	 * @param  {[type]} subsets [description]
	 * @return {[type]}         [description]
	 */
	removeSelection(subsets) {
		angular.forEach(subsets, (subset, index) => {
			this.moveSelectedFromTo(subset, this.unassigneds)
		});
	}

	/**
	 * Canelar selección
	 * @param  {[type]} subsets [description]
	 * @return {[type]}         [description]
	 */
	cancelSelection(subsets) {
		angular.forEach(subsets, (subset, index) => {
			angular.forEach(subset.attrs, function(item, key){
				// console.log(item);
				if(item._selected) delete item._selected;
			});
		});
	}

	/**
	 * [onDragstart description]
	 * @param  {[type]} list  [description]
	 * @param  {[type]} event [description]
	 * @return {[type]}       [description]
	 */
	onDragstart(list, event) {
		// Marcamos la lista que se está arrastrano
		list.dragging = true;
	}

	/**
	 * [onDragend description]
	 * @param  {[type]} list  [description]
	 * @param  {[type]} event [description]
	 * @return {[type]}       [description]
	 */
	onDragend(list, event) {
		// Quitamos el flag
		list.dragging = false;
	}

	/**
	 * [onMoved description]
	 * @param  {[type]} list [description]
	 * @return {[type]}      [description]
	 */
	onMoved(list) {
		// Borramos los elementos seleccionados de la lista, porqué son los movidos
		list.attrs = list.attrs.filter( (item) => { return !item._selected } )
		console.log('moved, List cleared', list);
	}

	/**
	 * [onDrop description]
	 * @param  {[type]} targetList [description]
	 * @param  {[type]} attrs      [description]
	 * @param  {[type]} position   [description]
	 * @return {[type]}            [description]
	 */
	onDrop(targetList, attrs, position) {
		// Marcamos los elementos como no seleccionados
		angular.forEach(attrs, (item) => item._selected = false );

		this.insertInto(targetList, attrs, position);
		return true;
	}

	/**
	 * [selectItem description]
	 * @param  {[type]}    item [description]
	 * @param  {...[type]} more [description]
	 * @return {[type]}         [description]
	 */
	selectItem(item, ...more) {
		console.log('selecting item', item, arguments, more);
		item._selected = !item._selected;
	}

	/**
	 * [getSelectionIncludingItem description]
	 * @param  {[type]} list [description]
	 * @param  {Object} item [description]
	 * @return {[type]}      [description]
	 */
	getSelectionIncludingItem(list, item = {}) {
		item._selected = true;
		return list.filter( (elem) => elem._selected );
	}

	/**
	 * [moveSelectedFromTo description]
	 * @param  {[type]} fromList [description]
	 * @param  {[type]} toList   [description]
	 * @return {[type]}          [description]
	 */
	moveSelectedFromTo(fromList, toList) {
		// attrs seleccionados
		let attrs = fromList.attrs.reduce((acc, item) => {
			if(item._selected){
				acc.push(item);
			}
			return acc;
		}, []);

		// Movemos los elementos
		this.insertInto(toList, attrs);

		// Eliminamos de la lista original
		fromList.attrs = fromList.attrs.filter( (item) => { return !item._selected } );

		// Marcamos los elementos como no seleccionados
		angular.forEach(attrs, (item) => item._selected = false );
	}

	/**
	 * Devuelve el número de items seleccionados de la lista
	 *
	 * @param  {[type]} list [description]
	 * @return {[type]}      [description]
	 */
	getTotalSelecteds(subsets) {
		// console.log(subsets);
		let total = 0;
		angular.forEach(subsets, (subset, index) => {
			// console.log(subset);
			total += subset.attrs.reduce((acc, item) => {
				if(item._selected){
					acc += 1;
				}
				return acc;
			}, 0);
		});

		return total;
	}

	/**
	 * [insertInto description]
	 * @param  {[type]} targetList [description]
	 * @param  {[type]} attrs      [description]
	 * @param  {Number} position   [description]
	 * @return {[type]}            [description]
	 */
	insertInto(targetList, attrs, position = 0) {
		// Añadimos los elementos a la lista
		targetList.attrs = targetList.attrs.slice(0, position)
			.concat(attrs) // insertamos los attrs en la posición
			.concat(targetList.attrs.slice(position));
	}

	/**
	 * Carga toda la composición de atributos, contemplando el padre
	 * @return {[type]} [description]
	 */
	showComposition() {
		if(! this.fullComposition) {
			this.AttributeGroup.subsetsComposition(this.group.id)
				.then( (fullComposition) => {
					this.fullComposition = fullComposition;
				});
		}

		this.showFullComposition = true;
	}

	/**
	 * [hideComposition description]
	 * @return {[type]} [description]
	 */
	hideComposition() {
		this.showFullComposition = false;
	}


	/**
	 * [save description]
	 * @param  {[type]} group [description]
	 * @return {[type]}       [description]
	 */
	save() {
		this.saving = true;

		this.AttributeGroup
			.save(this.group)
			.then( (group) => {
				this.saving = false;
				console.info('SAVED', group);
			});
	}
}

export default {
	template,
	controller,
	bindings: {
		group: '<?'
	}
};