import template from './cc-manager.template.html';

//@todo introducir 'lodash' como servicio
class controller {
	constructor($http, API_URL) {
		'ngInject';
		this.$http = $http;
		// this.API_URL = 'http://exes.local/cliccms/api/v1.0/';
		// this.API_URL = 'https://marketplace.tuandco.com/api/v1/';
		this.API_URL = API_URL; // @todo con un servicio
		// this.visibleFields = ['title', 'guid', 'created_at', 'updated_at'];
		this.visibleFields = [];
		this.filter = {};
		this.filterFields = [];
		this.order = {}; // Ordenable
		this.exporting = false;
	}

	/**
	 * [$onInit description]
	 * @return {[type]} [description]
	 */
	$onInit() {
		// No seguimos si no hay entidad
		if(!this.entity) return;

		this.loadResults();
		this.loadFilters();
	}

	/**
	 * [$doCheck description]
	 * @return {[type]} [description]
	 */
	$doCheck() {
		let refresh = false;

		// Si hay cambio de entidad, refrescamos los filtros
		if(this.entity && this.lasEntity != this.entity) {
			this.loadFilters();
		}

		this.lasEntity = this.entity;

		// Watch order object
		if(this.entity && ! angular.equals(this.latestOrder, this.order)){
			this.latestOrder = angular.copy(this.order);
			refresh = true;
		}

		// Watch visibile fields
		if(this.entity && ! angular.equals(this.oldVisibleFields, this.visibleFields)){
			this.oldVisibleFields = angular.copy(this.visibleFields);
			this.visibleFilterFields = _.filter(this.filterFields, (item) => {
				return _.indexOf(this.visibleFields, item.code) !== -1;
			});
			console.log(this.visibleFilterFields);
		}

		// Cambio de pagina
		if(this.hasOwnProperty('meta') && this.currentPage != this.meta.pagination.current_page){
			if(typeof this.currentPage !== 'undefined') {
				refresh = true;
			}
			this.currentPage = this.meta.pagination.current_page;
		}

		// Refresh results
		if(refresh){
			this.loadResults();
		}
	}

	/**
	 * [loadFilters description]
	 * @return {[type]} [description]
	 */
	loadFilters() {

		// Filtros
		this.$http.get(this.API_URL + '/filter/filterables/' + this.entity)
			.then( (res) => {
				this.filterFields = res.data;
				this.visibleFields = [];

				// Por defecto mostramos los 4 primeros
				// @todo mejorar
				for(let i=0; i<5; i++) {
					this.visibleFields.push(this.filterFields[i].code);
				}
			});
	}

	/**
	 * [loadResults description]
	 * @return {[type]} [description]
	 */
	loadResults() {
		// Prevent new search
		// @todo cancelar la anterior y iniciar una nueva
		if(this.loading == true) return;

		this.loading = true;

		// Limpiamos el filtro de campos vacíos
		angular.forEach(this.filter, (value, key) => {
			if(value == '') delete(this.filter[key]);
		});

		this.$http({
				// url:'http://tuandco.dev/api/v1/products?' + $.param({order: this.order, filter: this.filter}),
				url: this.API_URL + '/' + this.entity + '?' + $.param({order: this.order, filter: this.filter, page: (this.currentPage) ? this.currentPage : 1 }),
				// params: angular.merge({}, this.order, this.filter) //{ order: }, { filter: this.filter }
			})
			.then( (res) => {
				console.log('update results', res);
				this.data = res.data.data;
				this.meta = res.data.meta;
				// @TODO: no debe venir en esta consulta
				// if(!this.fields){ this.fields = res.data.meta.fields };
				this.loading = false;
				this.clearSelection();
			}, (error) => {
				this.error = error;
				this.loading = false;
			});
	}

	/**
	 * Número de items seleccionados
	 * @todo tener en cuenta cuando se seleccionan todos
	 * @return {[type]} [description]
	 */
	totalSelecteds() {
		return this.selection.length;
	}

	/**
	 * Borra la selección
	 * @return {[type]} [description]
	 */
	clearSelection() {
		this.selection = [];
	}

	/**
	 * [onlyVisibles description]
	 * @return {[type]} [description]
	 */
	onlyVisibles() {
		return this.visibleFilterFields;
	}

	/**
	 * Exportar datos
	 * @return {[type]} [description]
	 */
	export() {
		// ya está el proceso en ejecución
		if(this.exporting) return;

		this.exporting = true;
		this.$http({
				url: this.API_URL + '/export/' + this.entity + '?' + $.param({order: this.order, filter: this.filter}),
			})
			.then( (res) => {
				console.log('update results', res);
				// @todo mejorar
				// Abrir ruta de descarga
				window.location = res.data;
			}, (error) => {
				this.error = error;
			})
			.then( () => this.exporting = false );
	}
}

export default {
	template,
	controller,
	bindings: {
		view: '<',
		results: '<',
		filter: '=',
		entity: '<',
		actions: '=?'
	}
};