import template from './product-form.template.html';

class controller {
	constructor($q, State, Message, Product, Category, AttributeGroup, $uibModal) {
		'ngInject';
		this.$q = $q;
		this.State = State;
		this.Product = Product;
		this.Category = Category;
		this.AttributeGroup = AttributeGroup;
		this.$uibModal = $uibModal;
		this.msg = Message.new();
		this.attrs = [];
		this.values = {};
		this.product = {};
	}

	/**
	 * [$onInit description]
	 * @return {[type]} [description]
	 */
	$onInit() {
		console.log('Product', this, this.product, this.hasOwnProperty('product'));

		// Si no tiene grupo de atributo,, error
		// @todo -> permitir asignarle uno o una categoría
		if(!this.hasOwnProperty('product') || this.product == undefined  || !this.product.hasOwnProperty('product')|| this.product.attribute_group_id == null){
			this.showFeatures = true;
			this.msg.warn('El producto no tiene asignado un conjunto de atributos.');
			return;
		}

		// Cargamos producto
		this.loadProduct(this.id);
	}

	/**
	 * [$onChanges description]
	 * @param  {[type]} changeOb [description]
	 * @return {[type]}          [description]
	 */
	$onChanges(changeOb) {
		if(
			changeOb.hasOwnProperty('id')
			&& changeOb.id.currentValue
			&& changeOb.id.currentValue != changeOb.id.previousValue
		) {
			this.loadProduct(this.id);
		}

		// Conjuntos para seleccionar
		this.AttributeGroup
			.search()
			.then( (res) => {
				this.attributeGroups = res.data;
			});
	}

	/**
	 * [loadProduct description]
	 * @return {[type]} [description]
	 */
	loadProduct(id) {
		this.State.loading();
		let attributePromise, optionsPromise, categoryPromise;

		// Producto
		this.Product
			.get(id)
			.then( (product) => {
				this.product = product;

				// Cargamos el conjunto de atributos asociada
				attributePromise = this.AttributeGroup
											.get(this.product.attribute_group_id)
											.then( (group) => {
												this.group = group;
											});

				// Opciones de los selects
				optionsPromise = this.AttributeGroup
										.getOptions(this.product.attribute_group_id)
										.then( (options) => {
											this.options = options;
										});

				categoryPromise = this.Category
										.get(product.category_id)
										.then( (cat) => {
											console.log('cat', cat);
											this.category = cat;
										});

				this.$q.all([attributePromise, optionsPromise, categoryPromise])
					.then( () => {
						// Inicializamos los valores
						angular.forEach(this.product.attribute_values, (attribute, key) => {
							// El value no es convertido... @todo?
							this.values[attribute.attribute_reference.code] = attribute.value;
						});

						// Finalizados los procesos de carga de datos
						this.State.ready();
						this.msg.set('');
					});
			});

	}

	/**
	 * @todo
	 * Asignar el conjunto de atributos de la categoría seleccionada
	 * @param {[type]} group [description]
	 */
	setAttributeGroup(group) {
		console.log('sett', group);
		this.product.attribute_group_id = group.id;
	}

	/**
	 * Muetra la eidicón de los atributos
	 *
	 * @param  {[type]} subsetName [description]
	 * @param  {[type]} attrs      [description]
	 * @return {[type]}            [description]
	 */
	show(subsetName, attrs) {
		this.subsetSelected = subsetName;
		this.attrs = attrs;
	}

	/**
	 * Guardamos producto
	 * @return {[type]} [description]
	 */
	save() {
		console.log('Guardando datos de producto', this.values);
		this.State.loading();
		this.msg.warn('Guardando ....');

		this.Product
			// .save( angular.extend({}, {id: this.product.id}, this.values) )
			.save( angular.extend({}, this.product, this.values) )
			.then(
				(product) => {
					console.log('guardado', product);
					this.msg.success('Producto guardado correctamente').timeout(5000);
					this.clearErrors();
					this.loadProduct(product.id);
				},
				(response) => {
					this.msg.error('No se ha podido guardar');
					this.errors = response.data;
				}
			)
			.then( () => this.State.ready() );
	}

	/**
	 * Set category product
	 * @param {[type]} category [description]
	 */
	setCategory(category) {
		console.log('Setting categoru', category, arguments);
		this.product.category_id = category.id;
	}

	/**
	 * Clear errors
	 * @return {[type]} [description]
	 */
	clearErrors() {
		this.errors = false;
	}

	showEditor(fieldCode) {
		var modalInstance = this.$uibModal.open({
			templateUrl: 'wysiwg-editor.html',
			resolve: {
				content: () => {
					return this.values[fieldCode];
				}
			},
			controller: function($scope, content) {
				'ngInject';
				$scope.content = content;
			}
		});

		modalInstance.result.then( (editorContent) => {
			console.log('SEL', editorContent);
			this.values[fieldCode] = editorContent;
    	}, function () {
			// $log.info('Modal dismissed at: ' + new Date());
		});
	}
}


export default {
	template,
	controller,
	bindings: {
		id: '<?',
		product: '<?',
	}
}