import Api from './base-api.service';

export default class extends Api{

	constructor($http, $q, API_URL)  {
        'ngInject';
        super($http, $q, API_URL);
        super.setEntity('attribute-groups');
    }

	/**
	 * Atributos no asignados al conjunto
	 * @param  {[type]} groupId [description]
	 * @return {[type]}         [description]
	 */
	unassigneds(groupId) {
		let url = this.url(`${groupId}/unassigneds`);
		let deferred = this.$q.defer();

		this.$http
			.get(url)
			.then( (response) => {
				deferred.resolve(response.data);
			},
			(error) => {
				deferred.reject(error);
			});

		return deferred.promise;
	}

	/**
	 * Opciones del conjunto
	 * @param  {[type]} groupId [description]
	 * @return {[type]}         [description]
	 */
	getOptions(groupId) {
		console.log('Options of', groupId);
		let url = this.url(`${groupId}/options`);
		let deferred = this.$q.defer();

		this.$http
			.get(url)
			.then( (response) => {
				deferred.resolve(response.data);
			},
			(error) => {
				deferred.reject(error);
			});

		return deferred.promise;
	}

	/**
	 * Opciones del conjunto
	 * @param  {[type]} groupId [description]
	 * @return {[type]}         [description]
	 */
	composition(groupId) {
		console.log('Composition of', groupId);
		let url = this.url(`${groupId}/method/attribute-fields-composition`);
		let deferred = this.$q.defer();

		this.$http
			.get(url)
			.then( (response) => {
				deferred.resolve(response.data);
			},
			(error) => {
				deferred.reject(error);
			});

		return deferred.promise;
	}

	/**
	 * [subsetsComposition description]
	 * @param  {[type]} groupId [description]
	 * @return {[type]}         [description]
	 */
	subsetsComposition(groupId) {
		console.log('Composition of', groupId);
		let url = this.url(`${groupId}/method/subsets-composition`);
		let deferred = this.$q.defer();

		this.$http
			.get(url)
			.then( (response) => {
				deferred.resolve(response.data);
			},
			(error) => {
				deferred.reject(error);
			});

		return deferred.promise;
	}


	/**
	 * Conjuntos hijo
	 * @param  {[type]} groupId [description]
	 * @return {[type]}         [description]
	 */
	children(groupId) {
		let url = this.url(`${groupId}/children`);
		let deferred = this.$q.defer();

		this.$http
			.get(url)
			.then( (response) => {
				deferred.resolve(response.data.data);
			},
			(error) => {
				deferred.reject(error);
			});

		return deferred.promise;
	}

	/**
	 * Grupos padre
	 * @return {[type]} [description]
	 */
	roots() {
		let url = this.url(`roots`);
		let deferred = this.$q.defer();

		this.$http
			.get(url)
			.then( (response) => {
				deferred.resolve(response.data)
			},
			(error) => {
				deferred.reject(error)
			})

		return deferred.promise;
	}

	/**
	 * Grupos hijo (hojas)
	 * @return {[type]} [description]
	 */
	leafs() {
		let url = this.url(`leafs`);
		let deferred = this.$q.defer();

		this.$http
			.get(url)
			.then( (response) => {
				deferred.resolve(response.data)
			},
			(error) => {
				deferred.reject(error)
			})

		return deferred.promise;
	}
}