export default class {

    constructor($http, $q, API_URL) {
        this.$http = $http;
        this.$q = $q;
        this.API_URL = API_URL;
    }

    /**
     * [setEntity description]
     * @param {[type]} entity [description]
     */
    setEntity(entity) {
    	this.entity = entity;
    }

	/**
	 * [init description]
	 * @param  {[type]} entity [description]
	 * @return {[type]}        [description]
	 */
	url(url = '') {
        let baseUrl = this.API_URL + '/' + this.entity;
        if(url !== '') {
            return baseUrl + '/' + url;
        }

		return  baseUrl;
	}

    /**
     * [all description]
     * @param  {Array}  withRelations [description]
     * @return {[type]}               [description]
     */
    all(withRelations = []) {
        return this.$http({
            url: this.url('?' + $.param({ with: withRelations })),
        }).then( (response) => { return response.data });
    }

    /**
     * [get description]
     * @param  {[type]} id [description]
     * @return {[type]}    [description]
     */
	get(id, withRelations = []) {
		console.log('get', id);
		return this.$http({
			url: this.url(id + '?' + $.param({ with: withRelations })),
		}).then( (response) => { return response.data });
	}

    /**
     * [search description]
     * @param  {Object} filter [description]
     * @return {[type]}        [description]
     */
    search(filter = {}, order = false, onlyData = false, extra = {}){
        var srv = this,
            deferred = srv.$q.defer();

        // If the promise does not contain a hook into the deferred timeout,
        // the simply ignore the cancel request.
        if(srv._httpTimeout && srv._httpTimeout.resolve){
            // console.log('Debemos cancelar petición en curso', srv._httpTimeout);
            srv._httpTimeout.resolve();
            srv._httpTimeout = false;
        }

        var promise = srv.$http({
            method: 'GET',
            url: this.url('?' + $.param(angular.extend({}, {order, filter}, extra)) ),
            // url: srv.Admin.apiUrl('attribute-groups'),
            // params: {filter},
            timeout: deferred.promise
        }).then(
            (response) => {
                if(onlyData) {
                    return response.data.data;
                }

                // Incluye data y meta
                return response.data
            },
            (error) => { return error }
        );

        srv._httpTimeout = deferred;

        return promise;
    }

    /**
     * Create or update element
     * @param  {[type]} data [description]
     * @return {[type]}      [description]
     */
    save(data) {
        let url = this.url();
        if( data.hasOwnProperty('id') ){
            url += '/' + data.id;
        }

        return this.$http({
            url,
            method: 'POST',
            data: data
        }).then( (response) => { return response.data });
    }
}

// export default class {

// 	constructor($http, $q, API_URL) {
// 		'ngInject';
// 		this.entity = false;
// 		this.$http = $http;
// 		this.$q = $q;
// 		this.API_URL = API_URL;
// 	}

// 	/**
// 	 * [init description]
// 	 * @param  {[type]} entity [description]
// 	 * @return {[type]}        [description]
// 	 */
// 	init(entity) {
// 		this.entity = entity;
// 		return this;
// 	}



// 	/**
// 	 * [init description]
// 	 * @param  {[type]} entity [description]
// 	 * @return {[type]}        [description]
// 	 */
// 	all() {
// 		var srv = this;
// 		return srv._request({
// 			url: srv.url(srv.entity),
// 			method: 'GET'
// 		});
// 	}

// 	/**
// 	 * [init description]
// 	 * @param  {[type]} entity [description]
// 	 * @return {[type]}        [description]
// 	 */
// 	get(id) {
// 		var srv = this;
// 		return srv._request({
// 			url: srv.url(srv.entity + '/' + id),
// 			method: 'GET'
// 		});
// 	}

// 	/**
// 	 * Create
// 	 * @param  {[type]} data [description]
// 	 * @return {[type]}      [description]
// 	 */
// 	create(data) {
// 		var srv = this;
// 		return srv._request({
// 			url: srv.url(srv.entity),
// 			method: 'POST',
// 			data: data
// 		});
// 	}

// 	/**
// 	 * Save
// 	 * @param  {[type]} id   [description]
// 	 * @param  {[type]} data [description]
// 	 * @return {[type]}      [description]
// 	 */
// 	save(id, data) {
// 		console.log('Api Service - Guardando producto ', data);

// 		var srv = this;
// 		return srv._request({
// 			url: srv.url(srv.entity + '/' + id),
// 			method: 'POST',
// 			data: data
// 		});
// 	}

// 	/**
// 	 * [_request description]
// 	 * @param  {[type]} requestInfo [description]
// 	 * @return {[type]}             [description]
// 	 */
// 	_request(requestInfo) {
// 		var srv = this;
// 		var deferred = srv.$q.defer();
// 		srv
// 			.$http(requestInfo)
// 			.then( (response) => {
// 				deferred.resolve(response.data);
// 			}, (error) => {
// 				deferred.reject(error.data);
// 			});

// 		return deferred.promise;
// 	}
// }
