class AttributeGroupDemoController{

	constructor($q, $state, AttributeGroup) {
		'ngInject';
		this.$q = $q;
		this.$state = $state;
		this.AttributeGroup = AttributeGroup;
	}

	/**
	 * Inicializamos los conjuntos padre
	 *
	 * @return {[type]} [description]
	 */
	$onInit() {
		this.loading = true;

		// Cargamos conjutos de atributos padre
		let rootsPromise = this.AttributeGroup.roots()
			.then( (roots) => {
				this.roots = roots;
			});

		// Conjuntos en los que se puede basar
		let leafsPromise = this.AttributeGroup.leafs()
			.then( (leafs) => {
				this.leafs = leafs;
			});

		// Datos cargados -> mostramos formulario
		this.$q.all([rootsPromise, leafsPromise]).then( () => this.loading = false );
	}

	/**
	 * Guardar conjunto
	 * @param  {[type]} group [description]
	 * @return {[type]}       [description]
	 */
	create(group) {
		this.AttributeGroup
			.create(group)
			.then( (response) => {
				console.log('Conjunto guardado!', response);
				this.error = false;
				this.$state.go('attribute-group.edit', {id: response.id});
			}, (response) => {
				console.error(response);
				this.error = response.messages;
			});
	}
}

angular.module('DemoApp'). controller('AttributeGroupDemoController', ['$q', '$state', 'AttributeGroup', AttributeGroupDemoController]);