class SellerUploadDemo {

	constructor(API_URL, Upload, $http, $compile, $rootScope, $templateCache) {
		'ngInect';
		this.$http = $http;
		this.Upload = Upload;
		this.message = '';
		this.API_URL = API_URL;
		this.$compile = $compile;
		this.$rootScope = $rootScope;
		this.$templateCache = $templateCache;
		this.loading = false;
	}

	/**
	 * [$onInit description]
	 * @return {[type]} [description]
	 */
	$onInit() {
		// Sellers
		this.$http
			.get(this.API_URL + '/sellers')
			.then( (res) => {
				console.log(res);
				this.sellers = res.data.data;
			});
	}

	/**
	 * [$doCheck description]
	 * @return {[type]} [description]
	 */
	$doCheck() {
		// console.log(this.seller, this.oldSellerId);
		if(this.seller && this.oldSellerId != this.seller) {
			// console.log('update seller');
			this.loadJobs();
			this.oldSellerId = this.seller;
		}
	}

	/**
	 * [submit description]
	 * @param  {[type]} file [description]
	 * @return {[type]}      [description]
	 */
	submit(file) {
		// console.log('uploadinfg file', file, this);
		this.message = 'Subiendo fichero ...';
		this.loading = true;

		// upload on file select or drop
		this.Upload.upload({
			url: this.API_URL + '/catalog/upload',
			data: {catalog: file, seller: this.seller, notify: this.notify}
		}).then( (resp) => {
			// console.log('Success ' + resp.config.data.file.name + 'uploaded. Response: ' + resp.data);
			console.log('Success ', resp);
			this.message = 'Fichero subido:: ' + resp.data.message;
			this.loading = false;
			this.loadJobs();
		}, (resp) => {
			console.error('Error status: ', resp);
			this.message = 'Ha ocurrido un error al subir el fichero';
		}, (evt) => {
			var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
			console.log(evt, 'progress: ' + progressPercentage + '% ' + evt.config.data.file.name);
		});
	}

	/**
	 * [loadJobs description]
	 * @return {[type]} [description]
	 */
	loadJobs() {
		console.log('loading jobs...');
		this.$http
				.get(this.API_URL + '/sellers/'  + this.seller + '/import-jobs')
				.then( (res) => {
					console.log(res)
					this.jobs = res.data.data;
				});
	}

	/**
	 * [executeJob description]
	 * @param  {[type]} job [description]
	 * @return {[type]}     [description]
	 */
	executeJob(job){
		console.log('executing job', job.id);
	}

	/**
	 * [showLog description]
	 * @param  {[type]} id [description]
	 * @return {[type]}    [description]
	 */
	showLog(id) {
		let content = this.$templateCache.get('log-modal.html');
		let modal = angular.element('#log-modal');
		let contentLayer = modal.find('.modal-content');

		let scope = this.$rootScope.$new();
		scope.modal = {
			title: `Log del proceso #${id}`,
			body: 'cargando contenido ....'
		};

		contentLayer.html(this.$compile(content)(scope));
		modal.modal('show');

		this.$http({
					method: 'get',
					url: this.API_URL + '/import-jobs/'  + id + '/log',
					transformResponse: [function (data) {
					      // Do whatever you want!
					      console.log('transformResponse',data);
					      return data;
					  }]
				})
				.then( (res) => {
					console.log('get log!', res)
					scope.modal.body = res.data;
				});

	}

}

angular.module('DemoApp'). controller('SellerUploadDemo', SellerUploadDemo);