let app = angular.module('DemoApp', [
	'ui.router',
	// 'restangular',
	// 'chart.js',

	// App
	'tuandco-marketplace'
])
.config(configRoutes)
.constant('API_URL', window.API_URL)
;

/**
 * Routes
 * @param  {[type]} $stateProvider [description]
 * @return {[type]}                [description]
 */
function configRoutes($stateProvider, $urlRouterProvider) {
	let states = [
		// {
		// 	url: '/',
		// 	name: 'home',
		// 	// templateUrl: `/demo/views/home.html`
		// },
		{
			url: '/shippment-form',
			name: 'shippment-form',
			templateUrl: `/demo/views/shippment-form.demo.html`
		},
		{
			url: '/seller-form',
			name: 'seller-form',
			templateUrl: `/demo/views/seller-form.demo.html`
		},
		{
			url: '/seller-form/:id',
			name: 'seller-form-edit',
			templateUrl: `/demo/views/seller-form.demo.html`,
			resolve: {
				seller: function(Seller, $stateParams) {
					return Seller.get($stateParams.id);
				}
			}
		},
		{
			url: '/seller-upload',
			name: 'seller-upload',
			templateUrl: `/demo/views/seller-upload.demo.html`
		},
		{
			url: '/seller-dashboard',
			name: 'seller-dashboard',
			templateUrl: `/demo/views/seller-dashboard.demo.html`
		},

		{
			url: '/image-gallery',
			name: 'image-gallery',
			templateUrl: `/demo/views/image-gallery.demo.html`
		},

		{
			url: '/attribute-group',
			name: 'attribute-group',
			controller: 'AttributeGroupDemoController as $ctrl',
			templateUrl: `/demo/views/attribute-group.demo.html`
		},
		{
			url: '/create',
			name: 'attribute-group.create',
			controller: 'AttributeGroupDemoController as $ctrl',
			templateUrl: `/demo/views/attribute-group/attribute-group-create.demo.html`
		},
		{
			url: '/edit/:id',
			name: 'attribute-group.edit',
			component: 'ccAttributeGroupEditor',
			// controller: 'AttributeGroupDemoController as $ctrl',
			// templateUrl: `/demo/views/attribute-group/attribute-group-edit.demo.html`,
			resolve: {
				group: function($stateParams, AttributeGroup) {
					return AttributeGroup.get($stateParams.id);
				}
			}
		},
		{
			url: '/product-form',
			name: 'product-form',
			// controller: 'AttributeGroupDemoController as $ctrl',
			templateUrl: `/demo/views/product-form.demo.html`
		},
		{
			url: '/listings',
			name: 'listings',
			controller: 'ListingDemoController as vm',
			templateUrl: `/demo/views/listings.demo.html`
		},
		{
			url: '/seller-listing',
			name: 'seller-listing',
			controller: 'SellerListingDemo as $ctrl',
			templateUrl: `/demo/views/seller-listing.demo.html`
		}
	];

	states.forEach(function(state){
		$stateProvider.state(state);
	});

	$urlRouterProvider.otherwise('/');
}