'use strict';

var gulp = require('gulp');
var webpack = require('webpack-stream');
// Automatic load gulp plugins @see: https://www.npmjs.com/package/gulp-load-plugins
var $ = require('gulp-load-plugins')({ lazy: true }); 

// Config
var config = require('./gulp.config')();

/**
 * Default
 */
 gulp.task('default', ['watch']);

/**
 * Webpack
 */
 gulp.task('webpack', () => {

 	return gulp
	 	.src([config.js])
	 	.pipe($.plumber())
	 	.pipe(webpack(require('./webpack.config')))
	 	.pipe(gulp.dest( config.jsBuild ));
});

/**
 * Compass CSS
 */
 gulp.task('compass', () => {
 	return gulp
	 	.src(config.sass)
	 	.pipe($.compass({
	 		sass: config.sassDir,
	 		css: config.cssDir
		}))
	 	.pipe(gulp.dest( config.cssDir ));
});

/**
 * WATCH
 */
 gulp.task('watch', () => {
 	// @todo: verbose log directories in observation
 	gulp.watch(config.jsBaseDir + '**/*.*', ['webpack']);
 	gulp.watch(config.sassDir + '**/*.*', ['compass']);
});

/**
 * Test javascript
 */
 gulp.task('test', function(done){

	// Ejectuar tests
	var Server = require('karma').Server;
	new Server({
		configFile: __dirname + '/karma.conf.js',
		// singleRun: true
	}, done).start()
});
