/**
 * Compass with webpack
 * @see: http://stackoverflow.com/questions/32925570/how-to-configure-webpack-to-use-compass-in-my-project/32942568#32942568
 *
 */
let webpack = require('webpack');
let argv = require('yargs').argv;
let path = require('path');
var jsPath = './app';

// Plugins para todos los entornos
let commonPlugins = [
	new webpack.optimize.CommonsChunkPlugin({
        name: 'vendor',
        minChunks: function (module) {
           // this assumes your vendor imports exist in the node_modules directory
           return module.context && module.context.indexOf('node_modules') !== -1;
        }
    })
];

// Para buillo develop
let plugins = (argv.build)
	? [new webpack.optimize.UglifyJsPlugin()]
	: [];

/**
 * Config!
 * @type {Object}
 */
module.exports = {
	devtool: 'sourcemap',
	entry: {
		'tuandco-marketplace': jsPath+'/index',
	},
	output: {
		filename: '[name].js',
		path: __dirname + '/dist'
	},
	module: {
		rules: [
			// { test: /\.js$/, enforce: 'pre', exclude: [/node_modules/], loader: 'jshint-loader'}
		// ],
		// loaders: [
			{ test: /\.html$/, use: 'raw-loader' },
			{ test: /angular(\.min)?\.js$/, use: ["imports-loader?$=jquery"] },
       		{ test: /jquery(\.min)?\.js$/, use: ['expose-loader?jQuery']},
       		{ test: /tether\.js$/, use: ["expose-loader?Tether"] },
			{ test: /\.js$/, exclude: function(modulePath) {
				// @see: https://github.com/webpack/webpack/issues/2031
				return /node_modules/.test(modulePath)
						&& !/node_modules\/angular-manager-utilities/.test(modulePath)
						&& !/node_modules\/cliccms-package/.test(modulePath);
			}, use: ['ng-annotate-loader', 'babel-loader'] },
			{
				test: /\.scss$/,
				use: [
					{ loader: 'style-loader' },
					{ loader: 'css-loader' },
					{
						loader: 'sass-loader' ,
						options: {
							outputStyle: 'expanded',
							includePaths: [path.resolve(__dirname, './node_modules/compass-mixins/lib')]
						}
					}
				]
			},

			// the url-loader uses DataUrls.
			// the file-loader emits files.
			{ test: /\.woff(2)?(\?v=[0-9]\.[0-9]\.[0-9])?$/, use: { loader: "url-loader", options: { limit:10000, mimetype: "application/font-woff" }} },
			{ test: /\.(ttf|eot|svg)(\?v=[0-9]\.[0-9]\.[0-9])?$/, use: "file-loader" }
		]
	},
	plugins: plugins.concat(commonPlugins)
};